package cn.ibizlab.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;
import lombok.extern.slf4j.Slf4j;

import cn.ibizlab.util.security.SpringContextHolder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;
import org.springframework.util.Assert;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.sample.domain.IBIZSample0020;
import cn.ibizlab.core.sample.filter.IBIZSample0020SearchContext;
import cn.ibizlab.core.sample.service.IBIZSample0020Service;
import cn.ibizlab.core.sample.mapper.IBIZSample0020Mapper;
import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.security.AuthenticationUser;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import cn.ibizlab.core.sample.domain.IBIZSample0019;
import cn.ibizlab.core.sample.service.IBIZSample0019Service;


/**
 * 实体[员工] 服务对象接口实现
 */
@Slf4j
@Service("IBIZSample0020Service")
public class IBIZSample0020ServiceBase extends ServiceImpl<IBIZSample0020Mapper,IBIZSample0020> implements IBIZSample0020Service {

    @Autowired
    @Lazy
    protected IBIZSample0019Service ibizSample0019Service;
   

    protected int batchSize = 500;

    public IBIZSample0020 get(IBIZSample0020 et) {
        IBIZSample0020 rt = this.baseMapper.selectEntity(et);
        Assert.notNull(rt,"数据不存在,员工:"+et.getIbizsample0020Id());
        BeanUtils.copyProperties(rt, et);
        return et;
    }
    
    public List<IBIZSample0020> getByEntities(List<IBIZSample0020> entities) {
        return this.baseMapper.selectEntities(entities);
    }

    public void fillParentData(IBIZSample0020 et) {
        if(!ObjectUtils.isEmpty(et.getIbizsample0019Id())) {
            IBIZSample0019 ibizSample0019 = et.getIbizsample0019();
            if(!ObjectUtils.isEmpty(ibizSample0019)) {
                et.setIbizsample0019Name(ibizSample0019.getIbizsample0019Name());   
            }
        }    
    }

    public IBIZSample0020 getDraft(IBIZSample0020 et) {
        fillParentData(et);
        return et;
    }

    public Integer checkKey(IBIZSample0020 et) {
        fillParentData(et);
        return ( (!ObjectUtils.isEmpty(et.getIbizsample0020Id())) && this.count(Wrappers.<IBIZSample0020>query().eq("ibizsample0020id", et.getIbizsample0020Id()))>0 )?1:0;
    }

    @Override
    @Transactional
    public boolean create(IBIZSample0020 et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et))) 
            return false;
        get(et);
        return true;
    }
    @Transactional
    public boolean createBatch(List<IBIZSample0020> list) {
        list.forEach(et->fillParentData(et));
        this.saveBatch(list, batchSize);
        return true;
    }

    @Transactional
    public boolean update(IBIZSample0020 et) {
        fillParentData(et);
        UpdateWrapper qw=et.getUpdateWrapper(true);
        qw.eq("ibizsample0020id", et.getIbizsample0020Id());
        if(!update(et, qw)) {
            return false;
        }
        get(et);
        return true;
    }

    @Transactional
    public boolean updateBatch(List<IBIZSample0020> list) {
        list.forEach(et->fillParentData(et));
        updateBatchById(list, batchSize);
        return true;
    }

    @Transactional
    public boolean save(IBIZSample0020 et) {
        if(checkKey(et)>0)
            return getSelf().update(et);
        else
            return getSelf().create(et);
    }

    @Transactional
    public boolean saveBatch(List<IBIZSample0020> list) {
        List<IBIZSample0020> rt=this.getByEntities(list);
        Set<Serializable> keys=new HashSet<>();
        rt.forEach(et->{
            Serializable key = et.getIbizsample0020Id();
            if(!ObjectUtils.isEmpty(key))
                keys.add(key);
        });
        List<IBIZSample0020> _create=new ArrayList<>();
        List<IBIZSample0020> _update=new ArrayList<>();
        list.forEach(et-> {
            Serializable key = et.getIbizsample0020Id();
            if(keys.contains(key))
                _update.add(et);
            else
                _create.add(et);
        });
        List rtList=new ArrayList<>();
        if(_update.size()>0 && (!getSelf().updateBatch(_update)))
            return false;
        if(_create.size()>0 && (!getSelf().createBatch(_create)))
            return false;
        return true;
    }

    @Transactional
    public boolean remove(IBIZSample0020 et) {
        String key = et.getIbizsample0020Id();

        if(!remove(new QueryWrapper<IBIZSample0020>()
                .eq("ibizsample0020id", et.getIbizsample0020Id())
            )) {
            return false;
        }
        return true ;
    }

    @Transactional
    public boolean removeByEntities(List<IBIZSample0020> entities) {
        this.baseMapper.deleteEntities(entities);
        return true;
    }

    public Page<IBIZSample0020> searchDefault(IBIZSample0020SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0020> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBIZSample0020>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }
    public List<IBIZSample0020> listDefault(IBIZSample0020SearchContext context) {
        return baseMapper.listDefault(context,context.getSelectCond());
    }

    public List<IBIZSample0020> selectByIbizsample0019Id(String ibizsample0019Id) {
        return baseMapper.selectByIbizsample0019Id(ibizsample0019Id);
    }

    public boolean removeByIbizsample0019Id(String ibizsample0019Id) {
        return this.remove(new QueryWrapper<IBIZSample0020>().eq("ibizsample0019id",ibizsample0019Id));
    }

    public boolean resetByIbizsample0019Id(String ibizsample0019Id) {
        return this.update(new UpdateWrapper<IBIZSample0020>().set("ibizsample0019id",null).eq("ibizsample0019id",ibizsample0019Id));
    }

    public boolean saveByIbizsample0019(IBIZSample0019 ibizSample0019,List<IBIZSample0020> list) {
        if(list==null)
            return true;
        Set<String> delIds=new HashSet<String>();
        List<IBIZSample0020> _update=new ArrayList<IBIZSample0020>();
        List<IBIZSample0020> _create=new ArrayList<IBIZSample0020>();
        for(IBIZSample0020 before:selectByIbizsample0019Id(ibizSample0019.getIbizsample0019Id())){
            delIds.add(before.getIbizsample0020Id());
        }
        for(IBIZSample0020 sub:list) {
            sub.setIbizsample0019Id(ibizSample0019.getIbizsample0019Id());
            sub.setIbizsample0019(ibizSample0019);
            if(ObjectUtils.isEmpty(sub.getIbizsample0020Id()))
                sub.setIbizsample0020Id((String)sub.getDefaultKey(true));
            if(delIds.contains(sub.getIbizsample0020Id())) {
                delIds.remove(sub.getIbizsample0020Id());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0 && (!getSelf().updateBatch(_update)))
            return false;
        if(_create.size()>0 && (!getSelf().createBatch(_create)))
            return false;
        if(delIds.size()>0 && (!getSelf().removeBatch(delIds)))
            return false;
        return true;
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}